## therion 5.4.1ds1

=== Makefile ===
# common therion objects
export OUTDIR = .
CMNOBJECTS = thdate.o extern/shpopen.o extern/dbfopen.o \
  thexception.o thbuffer.o thmbuffer.o thlogfile.o thtmpdir.o thlocale.o \
  thparse.o thcmdline.o thconfig.o thinput.o thchenc.o thdatabase.o \
  thdataobject.o thdatareader.o thsurvey.o thendsurvey.o thdata.o \
  thperson.o thtf.o thtfangle.o thtflength.o thtfpwf.o \
  thdataleg.o thobjectname.o thinfnan.o thlayout.o thcomment.o \
  thinit.o thdb1d.o thsvxctrl.o thdatastation.o thobjectid.o \
  thobjectsrc.o thgrade.o thlibrary.o thgeomag.o thbezier.o \
  thexport.o thexporter.o thselector.o extern/img.o \
  thexpmodel.o thdb2d00.o thscrapis.o thcs.o thcsdata.o thexptable.o \
  thdb2d.o thscrap.o thendscrap.o th2ddataobject.o thdb2dprj.o \
  thdb2dpt.o thdb2dlp.o thdb2dab.o thdb2dji.o thdb2dmi.o thdb2dcp.o \
  thdb2dxm.o thdb2dxs.o thscraplo.o thscraplp.o thscrapen.o \
  thpoint.o thline.o tharea.o thlegenddata.o thmpost.o thsymbolsets.o \
  thjoin.o thmap.o thexpmap.o thlayoutln.o thlayoutclr.o thexpsys.o thexpuni.o \
  thconvert.o thpdf.o thpdfdbg.o thpdfdata.o thtexfonts.o \
  thsymbolset.o thlang.o thmapstat.o thexpdb.o thpic.o thsketch.o thproj.o \
  extern/lxMath.o extern/lxFile.o thdb3d.o thsurface.o thimport.o thsvg.o thepsparse.o \
  thtrans.o thwarpp.o thwarppt.o thwarppme.o thwarp.o thexpshp.o thattr.o thtex.o \
  extern/poly2tri/common/shapes.o extern/poly2tri/sweep/advancing_front.o extern/poly2tri/sweep/sweep.o extern/poly2tri/sweep/cdt.o extern/poly2tri/sweep/sweep_context.o \
  therion.o extern/proj4/libproj.a

CROSS =
EXT =

# PLATFORM CONFIG

# PLATFORM LINUX
##CXX = c++
##CC = gcc
##POBJECTS =
##LOCHEXE = loch/loch
##CXXPFLAGS = -DTHLINUX
##CCPFLAGS = -DTHLINUX
##LDPFLAGS = -s
##export THPLATFORM = LINUX
##OUTDIR = $(abspath $(PWD)/../therion.bin)
##THXTHMKCMD = $(OUTDIR)/therion


# PLATFORM DEBIAN
CXX = c++
CC = gcc
POBJECTS =
LOCHEXE = loch/loch
CXXPFLAGS = -DTHLINUX
CCPFLAGS = -DTHLINUX
LDPFLAGS = -s
export THPLATFORM = LINUX
THXTHMKCMD = ./therion


# PLATFORM WIN32
##CXX = c++
##CC = gcc
##POBJECTS = extern/getopt.o extern/getopt1.o therion.res extern/getline.o
##LOCHEXE = loch/loch
##CXXPFLAGS = -DTHWIN32
##CCPFLAGS = -DTHWIN32
##LDPFLAGS = -static-libgcc -static -s
##export THPLATFORM = WIN32
##OUTDIR = $(abspath $(PWD)/../therion.bin)
##THXTHMKCMD = $(OUTDIR)/therion

# PLATFORM WIN32CROSS
##CROSS = i686-w64-mingw32.static-
##EXT = .exe
##CXX = $(CROSS)c++
##export CC = $(CROSS)gcc
##export AR = $(CROSS)ar
##POBJECTS = extern/getopt.o extern/getopt1.o therion.res extern/getline.o
##LOCHEXE = loch/loch
##CXXPFLAGS = -DTHWIN32
##CCPFLAGS = -DTHWIN32
##LDPFLAGS = -static-libgcc -static -s
##export THPLATFORM = WIN32
##THXTHMKCMD = therion
##OUTDIR = $(abspath $(PWD)/../therion.bin)

# PLATFORM MACOSX
##CXX = c++
##CC = cc
##LOCHEXE = loch/loch
##POBJECTS = extern/getopt.o extern/getopt1.o extern/getline.o
##CXXPFLAGS = -DTHMACOSX
##CCPFLAGS = -DTHMACOSX
##LDPFLAGS =
##export THPLATFORM = MACOSX
##THXTHMKCMD = ./therion

# PLATFORM ENDCONFIG


# BUILD CONFIG

# BUILD OZONE
##CCBFLAGS = -O3
##CXXBFLAGS = -O3
##LDBFLAGS = $(LDPFLAGS)

# BUILD OXYGEN
CCBFLAGS = -O2
CXXBFLAGS = -O2
LDBFLAGS = $(LDPFLAGS)

# BUILD RELEASE
##CCBFLAGS =
##CXXBFLAGS =
##LDBFLAGS = $(LDPFLAGS)

# BUILD DEBUG
##CCBFLAGS = -ggdb
##CXXBFLAGS = -ggdb -DTHDEBUG
##LDBFLAGS =

# BUILD ENDCONFIG


# compiler settings
CXXFLAGS = -Wall $(CXXPFLAGS) $(CXXBFLAGS)
CCFLAGS = -DIMG_API_VERSION=1 -Wall $(CCPFLAGS) $(CCBFLAGS)
OBJECTS = $(addprefix $(OUTDIR)/,$(POBJECTS)) $(addprefix $(OUTDIR)/,$(CMNOBJECTS))


# linker settings
LIBS =
LDFLAGS = $(LDBFLAGS)


$(OUTDIR)/%.o : %.cxx
	$(CXX) -c $(CXXFLAGS) -o $@ $<

$(OUTDIR)/%.o : %.cc
	$(CXX) -c $(CXXFLAGS) -o $@ $<

$(OUTDIR)/%.o : %.c
	$(CC) -c $(CCFLAGS) -o $@ $<

all: version outdirs $(OUTDIR)/therion doc xtherion/xtherion $(LOCHEXE)

outdirs:
	mkdir -p $(OUTDIR)/extern/proj4
	mkdir -p $(OUTDIR)/extern/poly2tri/sweep/
	mkdir -p $(OUTDIR)/extern/poly2tri/common/
	mkdir -p $(OUTDIR)/loch
	mkdir -p $(OUTDIR)/xtherion
	mkdir -p $(OUTDIR)/thbook

version:
	python set_version.py


$(OUTDIR)/extern/proj4/libproj.a: extern/proj4/*.c extern/proj4/*.h
	$(MAKE) -C ./extern/proj4

$(OUTDIR)/therion: version $(OBJECTS)
	$(CXX) -Wall -o $(OUTDIR)/therion$(EXT) $(OBJECTS) $(LDFLAGS) $(LIBS)
ifneq ($(THPLATFORM),WIN32)
	$(MAKE) library
	$(MAKE) $(OUTDIR)/thlibrary.o
	$(CXX) -Wall -o $(OUTDIR)/therion$(EXT) $(OBJECTS) $(LDFLAGS) $(LIBS)
endif


$(OUTDIR)/therion.res: therion.rc
	$(CROSS)windres -i therion.rc -J rc -o $(OUTDIR)/therion.res -O coff

init:
	./therion --print-init-file > therion.ini

install: all
	tclsh makeinstall.tcl $(THPLATFORM)

minor-release:
	perl makerelease.pl

archive: config-debian unixify
	perl makearchive2.pl

release: clean
	perl makearchive.pl

binary: all doc
	perl makebinary.pl $(THPLATFORM)

depend:
	perl makedepend.pl > Makefile.dep
	perl maketest.pl Makefile.dep
	perl makefile.pl mv Makefile.dep Makefile
	$(CXX) -MM $(CXXFLAGS) *.cxx >> Makefile
	perl makedepend2.pl

library:
	$(THXTHMKCMD) --print-library-src thlibrarydata.thcfg > thlibrarydata.log
	$(THXTHMKCMD) --print-xtherion-src > xtherion/therion.tcl
	perl makelibrary.pl thlibrarydata.log > thlibrarydata.tmp
	perl maketest.pl thlibrarydata.tmp
	perl makefile.pl mv thlibrarydata.tmp thlibrarydata.cxx

xtherion/xtherion: version xtherion/*.tcl
	$(MAKE) -C ./xtherion

loch/loch: version loch/*.h loch/*.cxx loch/*.c
	$(MAKE) -C ./loch

doc: $(OUTDIR)/thbook/thbook.pdf

thbook: version $(OUTDIR)/thbook/thbook.pdf

samples: $(OUTDIR)/samples.doc/index.tex

$(OUTDIR)/samples.doc/index.tex:
	$(MAKE) -C samples
	touch thbook/version.tex
	$(MAKE) -C thbook

$(OUTDIR)/thbook/thbook.pdf: thbook/*.tex
	$(MAKE) -C thbook

clean:
	perl makefile.pl rm -q thlibrarydata.cxx ./xtherion/therion.tcl
	perl makefile.pl rmdir -q samples.doc
	$(MAKE) -C ./samples clean
	$(MAKE) cleanrest

cleanrest:
	$(MAKE) -C ./xtherion clean
	$(MAKE) -C ./loch clean
	$(MAKE) -C ./extern/proj4 clean
	perl makefile.pl rm -q thmpost.cxx thtex.h thlangdata.h thchencdata.cxx thcsdata.h thmpost.h thcsdata.cxx thtex.cxx thsymbolsetlist.h thsymbolsets.cxx thsymbolsets.h thlangdata.cxx thchencdata.h
	perl makefile.pl rm -q therion ./xtherion/xtherion ./xtherion/xtherion.tcl therion.exe *~ *.log *.o thchencdata/*~ .xtherion.dat ./xtherion/ver.tcl thversion.h thbook/version.tex
	perl makefile.pl rm -q xtherion/*~ .xth_thconfig_xth xtherion/screendump thlang/*~
	perl makefile.pl rm -q extern/*.o extern/*~ extern/poly2tri/common/*.o extern/poly2tri/sweep/*.o samples/*~ samples/*.log
	perl makefile.pl rm -q symbols.html therion.res
	perl makefile.pl rm -q tri/*.o tri/*~
	perl makefile.pl rm -q tex/*~
	perl makefile.pl rm -q us.stackdump loch/us.stackdump samples/us.stackdump xtherion/us.stackdump
	perl makefile.pl rm -q mpost/*~ examples/*~ examples/therion.log
	perl makefile.pl rm -q core symbols.xhtml cave.kml
	perl makefile.pl rm -q data.3d data.svx data.pos data.pts data.err data.plt
	perl makefile.pl rm -q cave.3d cave.lox cave.thm cave.pdf cave.sql cave.xhtml therion.tcl cave_a.pdf cave_m.pdf cave.vrml cave.wrl cave.3dmf cave.svg cave.tlx
	perl makefile.pl rm -q ./thbook/*~ ./thbook/thbook.log ./thbook/thbook.pdf ./lib/*~ ./mpost/*~ ./tex/*~
	perl makefile.pl rmdir -q doc thTMPDIR samples.doc symbols cave.shp tests/.doc
	perl makefile.pl rmdir -q doc symbols cave.shp tests/.doc
	perl makefile.pl rmdir -q thTMPDIR samples/*/thTMPDIR samples/*/*/thTMPDIR

thmpost.h: mpost/*.mp
	$(MAKE) -C ./mpost

thmpost.cxx: mpost/*.mp
	$(MAKE) -C ./mpost

thlibrarydata.cxx:
	perl makefile.pl cp thlibrarydata.src thlibrarydata.cxx

thsymbolsetlist.h: thsymbolsetlist.pl mpost/thTrans.mp
	perl thsymbolsetlist.pl

thtex.h: tex/*.tex
	$(MAKE) -C ./tex

thtex.cxx: tex/*.tex
	$(MAKE) -C ./tex

thchencdata.h: thchencdata/*.TXT
	$(MAKE) -C ./thchencdata

thcsdata.h: thcsdata.tcl
	tclsh thcsdata.tcl

update:
	$(MAKE) -C ./thlang update

unixify: clean
	tclsh makeunixify.tcl

thlangdata.h: thlang/texts.txt
	$(MAKE) -C ./thlang

config-debug:
	perl makeconfig.pl BUILD DEBUG
	$(MAKE) -C ./loch config-debug

config-release:
	perl makeconfig.pl BUILD RELEASE
	$(MAKE) -C ./loch config-release

config-oxygen:
	perl makeconfig.pl BUILD OXYGEN
	$(MAKE) -C ./loch config-oxygen

config-ozone:
	perl makeconfig.pl BUILD OZONE
	$(MAKE) -C ./loch config-ozone

config-debian:
	perl makeconfig.pl PLATFORM DEBIAN
	$(MAKE) -C ./loch config-debian

config-linux:
	perl makeconfig.pl PLATFORM LINUX
	$(MAKE) -C ./loch config-linux

config-win32:
	perl makeconfig.pl PLATFORM WIN32
	$(MAKE) -C ./loch config-win32

config-win32cross:
	perl makeconfig.pl PLATFORM WIN32CROSS
	$(MAKE) -C ./loch config-win32cross

config-macosx:
	perl makeconfig.pl PLATFORM MACOSX
	$(MAKE) -C ./loch config-macosx

# external sources
$(OUTDIR)/extern/lxMath.o: loch/lxMath.h loch/lxMath.cxx
	$(CXX) -c $(CXXFLAGS) -o $(OUTDIR)/extern/lxMath.o loch/lxMath.cxx

$(OUTDIR)/extern/lxFile.o: loch/lxFile.h loch/lxFile.cxx
	$(CXX) -c $(CXXFLAGS) -o $(OUTDIR)/extern/lxFile.o loch/lxFile.cxx

extern/getopt.o: extern/getopt.c extern/getopt.h
extern/getopt1.o: extern/getopt1.c
extern/img.o: extern/img.c extern/img.h
extern/poly2tri/common/shapes.o: extern/poly2tri/common/shapes.cc extern/poly2tri/common/shapes.h
extern/poly2tri/sweep/advancing_front.o: extern/poly2tri/sweep/advancing_front.cc
extern/poly2tri/sweep/sweep.o: extern/poly2tri/sweep/sweep.cc
extern/poly2tri/sweep/cdt.o: extern/poly2tri/sweep/cdt.cc
extern/poly2tri/sweep/sweep_context.o: extern/poly2tri/sweep/sweep_context.cc

# DEPENDENCIES
$(OUTDIR)/th2ddataobject.o: th2ddataobject.cxx th2ddataobject.h thdataobject.h \
 thdatabase.h thmbuffer.h thbuffer.h thdb1d.h thobjectid.h thinfnan.h \
 thdataleg.h thparse.h thobjectname.h therion.h thobjectsrc.h thdb3d.h \
 loch/lxMath.h thattr.h thchenc.h thchencdata.h thdb2d.h thdb2dprj.h \
 thmapstat.h thdate.h thperson.h thlegenddata.h thdb2dpt.h thdb2dlp.h \
 thdb2dab.h thdb2dji.h thdb2dmi.h thdb2dcp.h thdb2dxs.h thdb2dxm.h \
 thscraplo.h thlayoutln.h thlayoutclr.h thscrapen.h thscraplp.h \
 thexception.h thsymbolset.h thsymbolsetlist.h
$(OUTDIR)/tharea.o: tharea.cxx tharea.h th2ddataobject.h thdataobject.h \
 thdatabase.h thmbuffer.h thbuffer.h thdb1d.h thobjectid.h thinfnan.h \
 thdataleg.h thparse.h thobjectname.h therion.h thobjectsrc.h thdb3d.h \
 loch/lxMath.h thattr.h thchenc.h thchencdata.h thdb2d.h thdb2dprj.h \
 thmapstat.h thdate.h thperson.h thlegenddata.h thdb2dpt.h thdb2dlp.h \
 thdb2dab.h thdb2dji.h thdb2dmi.h thdb2dcp.h thdb2dxs.h thdb2dxm.h \
 thscraplo.h thlayoutln.h thlayoutclr.h thscrapen.h thscraplp.h \
 thexception.h thexpmap.h thexport.h thlayout.h thsymbolset.h \
 thsymbolsetlist.h thlocale.h thlang.h thlangdata.h thline.h
$(OUTDIR)/thattr.o: thattr.cxx thattr.h thmbuffer.h thchenc.h thchencdata.h \
 thparse.h thbuffer.h extern/shapefil.h thexception.h therion.h
$(OUTDIR)/thbezier.o: thbezier.cxx thbezier.h
$(OUTDIR)/thbuffer.o: thbuffer.cxx thbuffer.h
$(OUTDIR)/thchenc.o: thchenc.cxx thchenc.h thchencdata.h thparse.h thbuffer.h \
 thmbuffer.h thchencdata.cxx therion.h thexception.h
$(OUTDIR)/thchencdata.o: thchencdata.cxx
$(OUTDIR)/thcmdline.o: thcmdline.cxx thcmdline.h therion.h thlogfile.h thbuffer.h \
 thconfig.h thmbuffer.h thinput.h thparse.h thexporter.h thexport.h \
 thobjectsrc.h thlayout.h thdataobject.h thdatabase.h thdb1d.h \
 thobjectid.h thinfnan.h thdataleg.h thobjectname.h thdb3d.h \
 loch/lxMath.h thattr.h thchenc.h thchencdata.h thdb2d.h thdb2dprj.h \
 thmapstat.h thdate.h thperson.h thlegenddata.h thdb2dpt.h thdb2dlp.h \
 thdb2dab.h thdb2dji.h thdb2dmi.h thdb2dcp.h thdb2dxs.h thdb2dxm.h \
 thscraplo.h thlayoutln.h thlayoutclr.h thscrapen.h thscraplp.h \
 thsymbolset.h thsymbolsetlist.h thlocale.h thselector.h thtmpdir.h \
 extern/getopt.h
$(OUTDIR)/thcomment.o: thcomment.cxx thcomment.h thdataobject.h thdatabase.h \
 thmbuffer.h thbuffer.h thdb1d.h thobjectid.h thinfnan.h thdataleg.h \

=== loch/Makefile ===
OUTDIR ?= .
THPLATFORM ?= LINUX
ifneq ($(OUTDIR),.)
LOUTDIR = $(OUTDIR)/loch
else
LOUTDIR = .
endif



# common therion objects
CMNOBJECTS = \
  lxTR.o lxOGLFT.o lxSetup.o lxRender.o lxWX.o \
  lxImgIO.o lxLRUD.o lxFile.o lxSTree.o \
  lxData.o lxMath.o lxSView.o lxSScene.o \
  lxGUI.o lxGLC.o lxOptDlg.o lxAboutDlg.o lxPres.o \
  img.o

CROSS =
EXT =

VTKVERSION = $(shell tclsh ./getvtkver.tcl version)
VTKPATH = $(shell tclsh ./getvtkver.tcl incpath)
VTKLIBPATH = $(shell tclsh ./getvtkver.tcl libpath)
VTKV6 = $(shell tclsh ./getvtkver.tcl version6)
ifeq ($(VTKV6),1)
VTKLIBS = -lvtkCommonExecutionModel-$(VTKVERSION) -lvtkCommonDataModel-$(VTKVERSION) -lvtkCommonCore-$(VTKVERSION) -lvtkFiltersCore-$(VTKVERSION) -lvtkFiltersHybrid-$(VTKVERSION) -lvtkIOLegacy-$(VTKVERSION) -lfreetype -lpng -ljpeg
else
VTKLIBS = -lvtkHybrid -lvtkImaging -lvtkIO -lvtkGraphics -lvtkFiltering -lvtkCommon -lvtkjpeg -lvtkpng -lvtkzlib -lvtksys -lfreetype
endif
# VTKVERSION = 5.4
# VTKPATH = /usr/local/include/vtk-$(VTKVERSION)
# VTKLIBPATH = /usr/local/lib/vtk-$(VTKVERSION)
POSTMAKE =
STRIPFLAG = -s

# PLATFORM CONFIG

# PLATFORM LINUX
##CXX = c++
##CC = gcc
##POBJECTS = lxR2P.o
##ifeq ($(VTKV6),1)
##VTKLIBS = -lvtkCommonExecutionModel-$(VTKVERSION) -lvtkCommonDataModel-$(VTKVERSION) -lvtkCommonCore-$(VTKVERSION) -lvtkFiltersCore-$(VTKVERSION) -lvtkFiltersHybrid-$(VTKVERSION) -lvtkIOLegacy-$(VTKVERSION) -lfreetype -lpng -ljpeg
##else
##VTKLIBS = -lvtkHybrid -lvtkImaging -lvtkIO -lvtkGraphics -lvtkFiltering -lvtkCommon -lfreetype
##endif
##CXXPFLAGS = -DLXLINUX $(shell wx-config --cxxflags) -Wno-deprecated $(shell freetype-config --cflags) -I$(VTKPATH)
##CCPFLAGS = -DLXLINUX  $(shell wx-config --cflags)
##LXLIBDIR = linux
##PLIBS = $(shell wx-config --libs --gl-libs) -L$(VTKLIBPATH) $(VTKLIBS) -lGLU -lGL -lpthread -lX11 -lz
##LXPLATFORM = LINUX

# PLATFORM DEBIAN
CXX = c++
CC = gcc
POBJECTS = lxR2P.o
ifeq ($(VTKV6),1)
VTKLIBS = -lvtkCommonExecutionModel-$(VTKVERSION) -lvtkCommonDataModel-$(VTKVERSION) -lvtkCommonCore-$(VTKVERSION) -lvtkFiltersCore-$(VTKVERSION) -lvtkFiltersHybrid-$(VTKVERSION) -lvtkIOLegacy-$(VTKVERSION) -lfreetype -lpng -ljpeg
else
VTKLIBS = -lvtkHybrid -lvtkImaging -lvtkIO -lvtkGraphics -lvtkFiltering -lvtkCommon -lfreetype
endif
CXXPFLAGS = -DLXLINUX $(shell wx-config --cxxflags) -Wno-deprecated $(shell freetype-config --cflags) -I$(VTKPATH)
CCPFLAGS = -DLXLINUX  $(shell wx-config --cflags)
LXLIBDIR = linux
PLIBS = $(shell wx-config --libs --gl-libs) -L$(VTKLIBPATH) $(VTKLIBS) -lGLU -lGL -lpthread -lX11 -lz
LXPLATFORM = LINUX

# PLATFORM WIN32
##CXX = c++
##CC = gcc
##POBJECTS = loch.res lxR2D.o getline.o
##CXXPFLAGS = -W -Wall -DLXWIN32 $(shell wx-config --static --cxxflags) $(shell freetype-config --cflags) -I$(VTKPATH) -Wno-deprecated
##CCPFLAGS = -W -Wall -DLXWIN32 $(shell wx-config --static --cflags)
##LXLIBDIR = mingw
##PLIBS = $(shell freetype-config --libs) $(shell wx-config --static --libs --gl-libs) -L$(VTKLIBPATH) $(VTKLIBS)
##LXPLATFORM = WIN32
##STRIPFLAG = -static-libgcc -static -s

# PLATFORM WIN32CROSS
##CROSS= i686-w64-mingw32.static-
##EXT = .exe
##VTKPATH = /usr/lib/mxe/usr/i686-w64-mingw32.static/include/vtk-5.8
##VTKLIBPATH = /usr/lib/mxe/usr/i686-w64-mingw32.static/lib/vtk-5.8
##VTKLIBS = -lvtkHybrid -lvtkImaging -lvtkIO -lvtkGraphics -lvtkFiltering -lvtkCommon -lvtksys -lharfbuzz -lbz2 -lglib-2.0 -lintl -liconv -lws2_32 -lwinmm
##CXX = $(CROSS)c++
##CC = $(CROSS)gcc
##POBJECTS = loch.res lxR2D.o getline.o
##CXXPFLAGS = -W -Wall -std=gnu++11 -DLXWIN32 $(shell $(CROSS)wx-config --static --cxxflags) $(shell $(CROSS)freetype-config --cflags) -I$(VTKPATH) -Wno-deprecated
##CCPFLAGS = -W -Wall -DLXWIN32 $(shell $(CROSS)wx-config --static --cflags)
##LXLIBDIR =
##PLIBS = $(shell $(CROSS)freetype-config --libs) $(shell $(CROSS)wx-config --static --libs --gl-libs) -L$(VTKLIBPATH) $(VTKLIBS)
##LXPLATFORM = WIN32
##STRIPFLAG = -static-libgcc -static -s

# PLATFORM MACOSX
##CXX = c++
##CC = cc
##POBJECTS =
##CXXPFLAGS = -W -Wall -DLXMACOSX $(shell wx-config --cxxflags) $(shell freetype-config --cflags) -I$(VTKPATH) -Wno-deprecated -I/usr/X11R6/include -I/usr/X11R6/include/freetype2
##CCPFLAGS = -W -Wall -DLXMACOSX $(shell wx-config --cflags) -I/usr/X11R6/include
##LXLIBDIR =
##PLIBS = -lz -L/usr/X11R6/lib $(shell wx-config --libs --gl-libs) -L$(VTKLIBPATH) $(VTKLIBS)
##POSTMAKE = cp -f ./loch ./loch.app/Contents/MacOS
##STRIPFLAG =

# PLATFORM ENDCONFIG


# BUILD CONFIG

# BUILD OZONE
##CCBFLAGS = -O3
##CXXBFLAGS = -O3
##LDBFLAGS = $(STRIPFLAG)

# BUILD OXYGEN
CCBFLAGS = -O2
CXXBFLAGS = -O2
LDBFLAGS = $(STRIPFLAG)

# BUILD RELEASE
##CCBFLAGS =
##CXXBFLAGS =
##LDBFLAGS = $(STRIPFLAG)

# BUILD DEBUG
##CCBFLAGS = -ggdb
##CXXBFLAGS = -ggdb -DLXDEBUG
##LDBFLAGS =

# BUILD ENDCONFIG


# compiler settings
CXXFLAGS = -Wall -D_GNU_SOURCE -DLOCH $(CXXPFLAGS) $(CXXBFLAGS)
CCFLAGS = -Wall -D_GNU_SOURCE -DLOCH $(CCPFLAGS) $(CCBFLAGS)
OBJECTS = $(addprefix $(LOUTDIR)/,$(POBJECTS)) $(addprefix $(LOUTDIR)/,$(CMNOBJECTS))


# linker settings
LIBS = $(PLIBS)
LDFLAGS = $(LDBFLAGS)


$(LOUTDIR)/%.o : %.cxx
	$(CXX) -c $(CXXFLAGS) -o $@ $<

$(LOUTDIR)/%.o : %.cc
	$(CXX) -c $(CXXFLAGS) -o $@ $<

$(LOUTDIR)/%.o : %.c
	$(CC) -c $(CCFLAGS) -o $@ $<


all: $(LOUTDIR)/loch hlp

hlp:
	$(MAKE) -C ./help

$(LOUTDIR)/loch: $(OBJECTS)
	$(CXX) -o $(LOUTDIR)/loch$(EXT) -Wall $(OBJECTS) $(LIBS) $(LDFLAGS)
	$(POSTMAKE)

$(LOUTDIR)/loch.res: loch.rc loch.ico
	$(CROSS)windres -i loch.rc $(shell $(CROSS)wx-config --cflags | tr ' ' '\n' | grep "^-I" | tr '\n' ' ') -J rc -o $(LOUTDIR)/loch.res -O coff

graphs:
	dot -Tps graph-vispipe.dot -o graph-vispipe.ps


depend:
	perl makedepend.pl > Makefile.dep
	perl maketest.pl Makefile.dep
	perl makefile.pl mv Makefile.dep Makefile
	$(CXX) -DLXDEPCHECK -DLOCH -D'wxCHECK_VERSION(X,Y,Z)=1' -MM *.cxx >> Makefile
	$(CC) -DLXDEPCHECK -DLOCH -MM *.c >> Makefile
	perl makedepend2.pl


config-debug:
	perl makeconfig.pl BUILD DEBUG

test-release:
	zip -9 loch.zip loch.exe test.th test.jpg thconfig

config-release:
	perl makeconfig.pl BUILD RELEASE

config-oxygen:
	perl makeconfig.pl BUILD OXYGEN

config-ozone:
	perl makeconfig.pl BUILD OZONE

config-linux:
	perl makeconfig.pl PLATFORM LINUX

config-debian:
	perl makeconfig.pl PLATFORM DEBIAN

config-win32:
	perl makeconfig.pl PLATFORM WIN32

config-win32cross:
	perl makeconfig.pl PLATFORM WIN32CROSS

config-macosx:
	perl makeconfig.pl PLATFORM MACOSX

clean:
	perl makefile.pl rm -q *~
	perl makefile.pl rm -q help/*/*~
	perl makefile.pl rm -q loch.exe
	perl makefile.pl rm -q loch
	perl makefile.pl rm -q loch.app/Contents/MacOS/loch
	perl makefile.pl rm -q *.o
	perl makefile.pl rm -q *.log
	perl makefile.pl rm -q core
	perl makefile.pl rmdir -q .xvpics
	perl makefile.pl rm -q *.bmp
	perl makefile.pl rm -q *.ppm
	perl makefile.pl rm -q *.zip
	perl makefile.pl rm -q *.pdf
	perl makefile.pl rm -q *.png



# DEPENDENCIES
$(LOUTDIR)/lxAboutDlg.o: lxAboutDlg.cxx lxWX.h icons/about.xpm ../thversion.h
$(LOUTDIR)/lxData.o: lxData.cxx lxData.h lxMath.h lxImgIO.h lxFile.h lxLRUD.h
$(LOUTDIR)/lxFile.o: lxFile.cxx lxFile.h lxMath.h img.h ../extern/img.h
$(LOUTDIR)/lxGLC.o: lxGLC.cxx lxGLC.h lxMath.h lxGUI.h lxData.h lxImgIO.h lxFile.h \
 lxSetup.h lxSView.h lxWX.h lxFNT6x13_bdf.h lxFNT10x20_bdf.h \
 lxFNTFreeSans_ttf.h lxRender.h lxTR.h
$(LOUTDIR)/lxGUI.o: lxGUI.cxx lxGUI.h lxGLC.h lxMath.h lxData.h lxImgIO.h lxFile.h \
 lxSetup.h lxRender.h lxOptDlg.h lxAboutDlg.h lxSView.h lxWX.h lxSScene.h \
 lxSTree.h lxPres.h icons/open.xpm icons/render.xpm icons/reload.xpm \
 icons/stereo.xpm icons/rotation.xpm icons/lockrot.xpm icons/fit.xpm \
 icons/home.xpm icons/rendersetup.xpm icons/plan.xpm icons/profile.xpm \
 icons/fullscreen.xpm icons/orto.xpm icons/camera.xpm icons/scene.xpm \
 icons/viscline.xpm icons/vissurface.xpm icons/visbbox.xpm \
 icons/viswalls.xpm icons/visinds.xpm icons/visentrance.xpm \
 icons/visfix.xpm icons/visstation.xpm icons/vislabel.xpm loch.xpm
$(LOUTDIR)/lxImgIO.o: lxImgIO.cxx lxImgIO.h
$(LOUTDIR)/lxLRUD.o: lxLRUD.cxx lxLRUD.h lxMath.h
$(LOUTDIR)/lxMath.o: lxMath.cxx lxMath.h
$(LOUTDIR)/lxOGLFT.o: lxOGLFT.cxx lxOGLFT.h
$(LOUTDIR)/lxOptDlg.o: lxOptDlg.cxx lxWX.h lxGUI.h lxGLC.h lxMath.h
$(LOUTDIR)/lxPres.o: lxPres.cxx lxPres.h lxWX.h lxGUI.h lxGLC.h lxMath.h lxSetup.h \
 lxData.h lxImgIO.h lxFile.h loch.xpm
$(LOUTDIR)/lxRender.o: lxRender.cxx lxRender.h lxWX.h lxGLC.h lxMath.h lxGUI.h \
 lxSetup.h lxData.h lxImgIO.h lxFile.h lxTR.h
$(LOUTDIR)/lxSScene.o: lxSScene.cxx lxSScene.h lxWX.h lxGUI.h lxGLC.h lxMath.h \
 lxSetup.h lxData.h lxImgIO.h lxFile.h loch.xpm
$(LOUTDIR)/lxSTree.o: lxSTree.cxx lxSTree.h lxWX.h lxGUI.h lxGLC.h lxMath.h \
 lxSetup.h lxData.h lxImgIO.h lxFile.h loch.xpm
$(LOUTDIR)/lxSView.o: lxSView.cxx lxSView.h lxWX.h lxGUI.h lxGLC.h lxMath.h \
 lxSetup.h lxData.h lxImgIO.h lxFile.h loch.xpm
$(LOUTDIR)/lxSetup.o: lxSetup.cxx lxSetup.h lxData.h lxMath.h lxImgIO.h lxFile.h
$(LOUTDIR)/lxWX.o: lxWX.cxx lxWX.h
$(LOUTDIR)/getline.o: getline.c
$(LOUTDIR)/img.o: img.c ../extern/img.c ../extern/img.h
$(LOUTDIR)/lxR2D.o: lxR2D.c lxR2D.h
$(LOUTDIR)/lxR2P.o: lxR2P.c lxR2P.h
$(LOUTDIR)/lxTR.o: lxTR.c lxTR.h

=== thbook/Makefile ===
OUTDIR ?= .
ifneq ($(OUTDIR),.)
LOUTDIR = $(OUTDIR)/thbook
else
LOUTDIR = .
endif

all: $(LOUTDIR)/thbook.pdf

$(LOUTDIR)/thbook.pdf: *.tex
	pdftex thbook.tex
	pdftex thbook.tex    
	pdftex thbook.tex
	perl ../makefile.pl rm ./thbook.log
ifneq ($(OUTDIR),.)
	perl ../makefile.pl mv ./thbook.pdf $(LOUTDIR)
endif

=== xtherion/Makefile ===
OUTDIR ?= .
THPLATFORM ?= LINUX
ifneq ($(OUTDIR),.)
LOUTDIR = $(OUTDIR)/xtherion
else
LOUTDIR = .
endif


ifeq ($(THPLATFORM),WIN32)
TARGET = xtherion.tcl
else
TARGET = xtherion
endif

all: $(LOUTDIR)/$(TARGET)

$(LOUTDIR)/$(TARGET): *.tcl msgxth.tcl
	tclsh mkall.tcl $(THPLATFORM)
ifneq ($(OUTDIR),.)
	perl ../makefile.pl mv ./$(TARGET) $(LOUTDIR)
endif

survex:
	tclsh mkall.tcl survex
	tar -cvzf ../../../svxedit.tar.gz svxedit
	perl ../makefile.pl rm -q svxedit

clean:
	perl ../makefile.pl rm -q *~
	perl ../makefile.pl rm -q ../../bin/xtherion
	perl ../makefile.pl rm -q lang/*~
	perl ../makefile.pl rm -q svxedit
	perl ../makefile.pl rm -q msgxth.tcl
	perl ../makefile.pl rm -q xtherion.tar.gz
	perl ../makefile.pl rm -q svxedit.tar.gz
	perl ../makefile.pl rm -q err.log

update:
	$(MAKE) -C ./lang update
  
msgxth.tcl: lang/xtexts.txt
	$(MAKE) -C ./lang

=== extern/proj4/Makefile ===
AR ?= ar
CC ?= cc
OUTDIR ?= .
ifneq ($(OUTDIR),.)
LOUTDIR = $(OUTDIR)/extern/proj4
else
LOUTDIR = .
endif
OBJECTS = $(addprefix $(LOUTDIR)/,$(addsuffix .o,$(basename $(shell ls *.c))))


$(LOUTDIR)/%.o : %.c
	$(CC) -c $(CCFLAGS) -I. -o $@ $<


all: $(LOUTDIR)/libproj.a

$(LOUTDIR)/libproj.a: $(OBJECTS)
	$(AR) cr $(LOUTDIR)/libproj.a $(LOUTDIR)/*.o

remove:
	rm -f proj.c gen_cheb.c p_series.c jniproj.c cs2cs.c \
	cs2cs.c gen_cheb.c p_series.c nad2nad.c nad2bin.c \
	geod.c geod_set.c geod_for.c geod_inv.c geodesic.h

clean:
	perl ../../makefile.pl rm *.o
	perl ../../makefile.pl rm *~
	perl ../../makefile.pl rm *.a

=== loch/help/Makefile ===
all:
	$(MAKE) -i -C ./en
	$(MAKE) -i -C ./sk

=== debian/changelog ===
therion (5.4.1ds1-2) unstable; urgency=medium

  * Build with GTK3 version of wxWidgets 3.0.
  * debian/README.Debian: Fix typos: "proces" -> "process" and
    "texlive-lang-czeckslovak" -> "texlive-lang-czechslovak".
  * debian/control: Mark conformance with policy 4.1.3 - changes:
    + debian/control: Update section from "extra" to "optional" - "extra" was
      deprecated by policy version 4.0.1.

 -- Olly Betts <olly@survex.com>  Fri, 23 Mar 2018 10:06:17 +1300

therion (5.4.1ds1-1) unstable; urgency=medium

  * New upstream release.
  * Upload to unstable.
  * debian/control: Declare conformance with policy 4.0.0.
  * debian/copyright: Drop comment with obsolete poly2tri URL.
  * debian/copyright: Update copyright years.
  * debian/watch: Add dversionmangle.

 -- Olly Betts <olly@survex.com>  Thu, 29 Jun 2017 09:59:00 +1200

therion (5.4.0ds1-1) experimental; urgency=medium

  * New upstream release:
    + Incorporates many changes we were carrying as patches, so prune
      and update all the patches.
    + debian/control: Upstream removed self-dependency, so drop "therion"
      from "Build-Depends".
    + debian/watch: Upstream tarballs are now served from github.
    + debian/copyright: Remove junk files from excluded list which are no
      longer present in upstream tarball.
  * debian/watch: Repack tarball to exclude .chm files which can't be rebuilt
    from source using DFSG-free tools.
  * debian/rules: Package i18n message files for loch.
  * debian/*: Use https for all URLs on upstream website.
  * debian/README.Debian:
    + Update information about TeX fonts now that upstream has added
      "tex-fonts-optional".
    + Drop teTex-specific details - teTeX has been dead upstream since 2006
      and Debian switched to TeX Live ages ago.
    + Fix "use use" typo.

 -- Olly Betts <olly@survex.com>  Thu, 06 Apr 2017 07:43:50 +1200

therion (5.3.16-10) unstable; urgency=medium

  * Update extern poly2tri URL from googlecode to github
  * Update for policy 3.9.7 (Remove obsolete menu files)
  * Clean loch (Windows) help files
  * Make thbook and samples build reproducible

 -- Wookey <wookey@debian.org>  Tue, 29 Mar 2016 02:00:53 +0100

therion (5.3.16-9) unstable; urgency=medium

  * Correct german translation for "color-legend-altitude"
  * Do not force gcc as compiler
  * More colours and keyboard shortcuts in xtherion.
  Thanks to Vladimir Geogiev
  * Allows map-colours to be specified: colour map-fg [map]
  Thanks to Olly Betts
  * Use previous therion version to build

 -- Wookey <wookey@debian.org>  Fri, 19 Feb 2016 14:44:39 +0000

=== debian/control ===
Source: therion
Section: science
Priority: optional
Maintainer: Wookey <wookey@debian.org>
Uploaders: Olly Betts <olly@survex.com>
Build-Depends: dpkg (>=1.16.2), debhelper (>= 9), perl (>= 5.5), tcl, 
  libvtk6-dev, libwxgtk3.0-gtk3-dev, libfreetype6-dev, libjpeg-dev, libpng-dev, 
  pkg-config, texlive-base, libproj-dev
Build-Depends-Indep: texlive-metapost, imagemagick, ghostscript 
Standards-Version: 4.1.3
Homepage: https://therion.speleo.sk/

Package: therion
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, tcl, texlive-base, texlive-metapost, bwidget
Recommends: evince | pdf-viewer, libtk-img, therion-viewer, survex
Suggests: survex-aven, texlive-lang-czechslovak, texlive-lang-cyrillic
Description: Cave surveying - 2D and 3D drawing software
 Therion aids the process of drawing up cave surveys (maps). Drawings are 
 done over scans and can be distorted to fit the centreline data. Output is 
 in single sheet or atlas style PDF or SVG files. All data is stored in text 
 files and a map editor (xtherion) is provided to aid in the creation of the 
 files. A wide range of co-ordinate systems is supported. 
 .
 Therion can also produce 3D models, generated from walls and
 passage-heights.  Output formats supported are Survex .3d files, VRML, DXF,
 SVG, shapefiles, and the native .lox. Scanned map overlays and relief data
 can be incorporated into models. Therion is compatible with Survex, and
 centreline data can be stored in Survex or Therion form. If survex is
 installed it is used for loop closures. Centreline data and sketches can be
 imported from PocketTopo, allowing full paperless surveying.
 .
 TeX and metapost are used to generate the images. libtk-img is needed to use 
 scans in formats other than GIF and PNM (such as PNG and JPEG).
 Survex will be used for loop-closure if installed, but is not required.
 .
 You will need appropriate TeX language packages to process therion files which 
 specify those character sets: texlive-lang-czechslovak is needed to process 
 the examples, and texlive-lang-cyrillic is also suggested. See README.Debian 
 for details.

Package: therion-viewer
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, therion
Description: Cave surveying - 3D viewer for therion models
 Therion is cave-survey drawing and modelling software. This package contains 
 the 3D model viewer for therion models produced by version 0.4 or later.
 
Package: therion-doc
Section: doc
Architecture: all
Recommends: therion 
Depends: ${misc:Depends}
Replaces: therion (<< 0.5.0)
Description: Documentation for Therion Cave surveying software 
 Therion is cave-survey drawing and modelling software. This package
 includes the thbook which is the specification for the therion data
 description language. This is not the easiest way to get started;
 there is much more documentation in the Therion wiki:
 https://therion.speleo.sk/wiki/doku.php with introductory guides, FAQs
 and examples. Read those first to get an understanding of how it is
 used.

=== debian/rules ===
#!/usr/bin/make -f
# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

clean:
	dh_testdir
	dh_testroot
	# Add here commands to clean up after the build process.
	rm -f man/therion-viewer.1
	$(MAKE) -C samples clean
	dh_auto_clean
	dh_clean

build: build-arch build-indep

build-indep:
	# just build the -doc package 
	dh_testdir
        

ifeq ($(DEB_BUILD_ARCH),$(DEB_HOST_ARCH))
	# We need therion itself to build the samples
	$(MAKE) therion 
	# create HTML documentation for samples
	$(MAKE) samples
endif
	$(MAKE) thbook
	touch build-indep-stamp

build-arch:
	dh_testdir
	# Compile the binaries
	$(MAKE) therion xtherion/xtherion loch/loch
	ln -sf loch.1 man/therion-viewer.1
	# create therion.ini file:
	#$(MAKE) init
	touch build-arch-stamp

binary: binary-arch binary-indep

# Package architecture-independent packages here.
binary-indep: DH_OPTIONS=-i
binary-indep: build-indep-stamp
	# just build the -doc package 
	dh_testdir
	dh_testroot

ifeq ($(DEB_BUILD_ARCH),$(DEB_HOST_ARCH))
	#if cross-building these won't have been generated, so skip
	dh_installdocs -ptherion-doc samples.doc
endif
	dh_install -Ntherion-viewer -Ntherion
	dh_installchangelogs CHANGES
	#we should generate html of thbook here too if possible
	dh_compress -ptherion-doc -X.pdf -X.th -X.th2 -Xthconfig
	dh_fixperms -Ntherion-viewer -Ntherion
	dh_installdeb -Ntherion-viewer -Ntherion
	dh_gencontrol -Ntherion-viewer -Ntherion
	dh_md5sums -Ntherion-viewer -Ntherion
	dh_builddeb -Ntherion-viewer -Ntherion

# Package architecture-dependent files here.
binary-arch: DH_OPTIONS=-a
binary-arch: build-arch-stamp 
	dh_testdir
	dh_testroot
	dh_installdirs

	# Add here commands to install the package into debian/therion.
#this stuff no longer needed from 0.2.14
#but it would be nice to put it back
#	install -d -o root -g root -m 755 debian/therion/usr/share/texmf/metapost/therion
#	install -d -o root -g root -m 755 debian/therion/usr/share/texmf/tex/therion
#	install -p -o root -g root -m 644 mpost/*.mp debian/therion/usr/share/texmf/metapost/therion/
#	install -p -o root -g root -m 644 tex/*.tex debian/therion/usr/share/texmf/tex/therion/
	dh_install -Ntherion-doc
	cd loch/locale && for lang in * ; do \
	  install -D "$$lang/loch.mo" "debian/tmp/therion-viewer/usr/share/locale/$$lang/LC_MESSAGES/loch.mo" ; \
	done
	dh_installdocs README
	dh_installdocs -ptherion-viewer loch/help/en/loch.htm
	# we need to clear out large generated files from samples before putting just source files in main package
	$(MAKE) -C samples clean
	dh_installexamples -ptherion  --exclude=.tcl --exclude=Makefile --exclude=thTMPDIR samples thconfig therion.ini
	dh_installmenu
	dh_installmime
	dh_icons
	dh_installman -ptherion man/therion.1 man/xtherion.1
	dh_installman -ptherion-viewer man/loch.1 man/therion-viewer.1
	dh_installchangelogs CHANGES
	dh_strip
	dh_compress -X.pdf -X.th -X.th2 -Xthconfig
	dh_fixperms -Ntherion-doc
	dh_installdeb -Ntherion-doc
	dh_shlibdeps -Ntherion-doc
	dh_gencontrol -Ntherion-doc
	dh_md5sums -Ntherion-doc
	dh_builddeb -Ntherion-doc

.PHONY: build clean binary-indep binary-arch binary install configure

=== debian/watch ===
# Run the "uscan" command to check for upstream updates.
version=3
opts="repacksuffix=ds1,dversionmangle=s/\+ds\d*$//" http://therion.speleo.sk/download.php \
 https://github.com/therion/therion/archive/v(.*)\.tar\.gz debian uupdate

## therion 5.4.2ds1

=== Makefile ===
--- 
+++ 
@@ -5,7 +5,7 @@
   thparse.o thcmdline.o thconfig.o thinput.o thchenc.o thdatabase.o \
   thdataobject.o thdatareader.o thsurvey.o thendsurvey.o thdata.o \
   thperson.o thtf.o thtfangle.o thtflength.o thtfpwf.o \
-  thdataleg.o thobjectname.o thinfnan.o thlayout.o thcomment.o \
+  thdataleg.o thobjectname.o thinfnan.o thlayout.o thlookup.o thcomment.o \
   thinit.o thdb1d.o thsvxctrl.o thdatastation.o thobjectid.o \
   thobjectsrc.o thgrade.o thlibrary.o thgeomag.o thbezier.o \
   thexport.o thexporter.o thselector.o extern/img.o \
@@ -20,10 +20,15 @@
   extern/lxMath.o extern/lxFile.o thdb3d.o thsurface.o thimport.o thsvg.o thepsparse.o \
   thtrans.o thwarpp.o thwarppt.o thwarppme.o thwarp.o thexpshp.o thattr.o thtex.o \
   extern/poly2tri/common/shapes.o extern/poly2tri/sweep/advancing_front.o extern/poly2tri/sweep/sweep.o extern/poly2tri/sweep/cdt.o extern/poly2tri/sweep/sweep_context.o \
-  therion.o extern/proj4/libproj.a
+  therion.o extern/quickhull/QuickHull.o
 
 CROSS =
 EXT =
+
+# Prefix to install to (override like so: make PREFIX=/usr)
+PREFIX = /usr/local
+# Directory to install config files in (override like so: make SYSCONFDIR=/etc)
+SYSCONFDIR = $(PREFIX)/etc
 
 # PLATFORM CONFIG
 
@@ -117,21 +122,36 @@
 
 # BUILD ENDCONFIG
 
+# PROJ CONFIG
+
+# PROJ BUNDLED
+##CMNOBJECTS += extern/proj4/libproj.a
+##CXXJFLAGS = -Iextern/proj4
+
+# PROJ SYSTEM
+PROJ_LIBS = $(shell $(CROSS)pkg-config proj --libs)
+CXXJFLAGS = -I$(shell $(CROSS)pkg-config proj --variable=includedir)
+
+
+# PROJ ENDCONFIG
 
 # compiler settings
-CXXFLAGS = -Wall $(CXXPFLAGS) $(CXXBFLAGS)
+CXXFLAGS = -Wall $(CXXPFLAGS) $(CXXBFLAGS) $(CXXJFLAGS) -std=c++11
 CCFLAGS = -DIMG_API_VERSION=1 -Wall $(CCPFLAGS) $(CCBFLAGS)
 OBJECTS = $(addprefix $(OUTDIR)/,$(POBJECTS)) $(addprefix $(OUTDIR)/,$(CMNOBJECTS))
 
 
 # linker settings
-LIBS =
+LIBS = $(PROJ_LIBS)
 LDFLAGS = $(LDBFLAGS)
 
 
 $(OUTDIR)/%.o : %.cxx
 	$(CXX) -c $(CXXFLAGS) -o $@ $<
 
+$(OUTDIR)/%.o : %.cpp
+	$(CXX) -c $(CXXFLAGS) -o $@ $<
+
 $(OUTDIR)/%.o : %.cc
 	$(CXX) -c $(CXXFLAGS) -o $@ $<
 
@@ -141,9 +161,9 @@
 all: version outdirs $(OUTDIR)/therion doc xtherion/xtherion $(LOCHEXE)
 
 outdirs:
-	mkdir -p $(OUTDIR)/extern/proj4
 	mkdir -p $(OUTDIR)/extern/poly2tri/sweep/
 	mkdir -p $(OUTDIR)/extern/poly2tri/common/
+	mkdir -p $(OUTDIR)/extern/quickhull
 	mkdir -p $(OUTDIR)/loch
 	mkdir -p $(OUTDIR)/xtherion
 	mkdir -p $(OUTDIR)/thbook
@@ -153,6 +173,7 @@
 
 
 $(OUTDIR)/extern/proj4/libproj.a: extern/proj4/*.c extern/proj4/*.h
+	mkdir -p $(OUTDIR)/extern/proj4
 	$(MAKE) -C ./extern/proj4
 
 $(OUTDIR)/therion: version $(OBJECTS)
@@ -171,7 +192,7 @@
 	./therion --print-init-file > therion.ini
 
 install: all
-	tclsh makeinstall.tcl $(THPLATFORM)
+	tclsh makeinstall.tcl $(THPLATFORM) $(PREFIX) $(SYSCONFDIR)
 
 minor-release:
 	perl makerelease.pl
@@ -338,7 +359,7 @@
  loch/lxMath.h thattr.h thchenc.h thchencdata.h thdb2d.h thdb2dprj.h \
  thmapstat.h thdate.h thperson.h thlegenddata.h thdb2dpt.h thdb2dlp.h \
  thdb2dab.h thdb2dji.h thdb2dmi.h thdb2dcp.h thdb2dxs.h thdb2dxm.h \
- thscraplo.h thlayoutln.h thlayoutclr.h thscrapen.h thscraplp.h \
+ thlayoutclr.h thscraplo.h thlayoutln.h thscrapen.h thscraplp.h \
  thexception.h thsymbolset.h thsymbolsetlist.h
 $(OUTDIR)/tharea.o: tharea.cxx tharea.h th2ddataobject.h thdataobject.h \
  thdatabase.h thmbuffer.h thbuffer.h thdb1d.h thobjectid.h thinfnan.h \
@@ -346,7 +367,7 @@
  loch/lxMath.h thattr.h thchenc.h thchencdata.h thdb2d.h thdb2dprj.h \
  thmapstat.h thdate.h thperson.h thlegenddata.h thdb2dpt.h thdb2dlp.h \
  thdb2dab.h thdb2dji.h thdb2dmi.h thdb2dcp.h thdb2dxs.h thdb2dxm.h \
- thscraplo.h thlayoutln.h thlayoutclr.h thscrapen.h thscraplp.h \
+ thlayoutclr.h thscraplo.h thlayoutln.h thscrapen.h thscraplp.h \
  thexception.h thexpmap.h thexport.h thlayout.h thsymbolset.h \
  thsymbolsetlist.h thlocale.h thlang.h thlangdata.h thline.h
 $(OUTDIR)/thattr.o: thattr.cxx thattr.h thmbuffer.h thchenc.h thchencdata.h \
@@ -359,12 +380,3 @@
 $(OUTDIR)/thcmdline.o: thcmdline.cxx thcmdline.h therion.h thlogfile.h thbuffer.h \
  thconfig.h thmbuffer.h thinput.h thparse.h thexporter.h thexport.h \
  thobjectsrc.h thlayout.h thdataobject.h thdatabase.h thdb1d.h \
- thobjectid.h thinfnan.h thdataleg.h thobjectname.h thdb3d.h \
- loch/lxMath.h thattr.h thchenc.h thchencdata.h thdb2d.h thdb2dprj.h \
- thmapstat.h thdate.h thperson.h thlegenddata.h thdb2dpt.h thdb2dlp.h \
- thdb2dab.h thdb2dji.h thdb2dmi.h thdb2dcp.h thdb2dxs.h thdb2dxm.h \
- thscraplo.h thlayoutln.h thlayoutclr.h thscrapen.h thscraplp.h \
- thsymbolset.h thsymbolsetlist.h thlocale.h thselector.h thtmpdir.h \
- extern/getopt.h
-$(OUTDIR)/thcomment.o: thcomment.cxx thcomment.h thdataobject.h thdatabase.h \
- thmbuffer.h thbuffer.h thdb1d.h thobjectid.h thinfnan.h thdataleg.h \

=== debian/changelog ===
therion (5.4.2ds1-1) unstable; urgency=medium

  * New upstream release
    + Drop patches applied upstream:
      - 05pkg-config-for-freetype.patch
      - 95use-external-libproj.patch
      - 98reproducible-mpost.patch
      - 99reproducible-tcl-glob.patch
    + Adjust remaining patches for upstream changes.
  * debian/control: Declare conformance with policy 4.3.0.
  * debian/therion.override: Override false Lintian warning for "posible"
    (which is a Spanish word here, not a misspelled English one).

 -- Olly Betts <olly@survex.com>  Wed, 09 Jan 2019 09:34:28 +1300

therion (5.4.1ds1-7) unstable; urgency=medium

  * debian/therion.override: Override Lintian warnings due to Lintian
    known bugs or overeagerness.
  * debian/control: Mark therion-doc as "Multi-Arch: foreign".
  * debian/patches/99reproducible-tcl-glob.patch: Sort list of files returned
    by Tcl's glob function.
  * therion-viewer.7: Move therion-viewer man page to section 7 - section 1 is
    meant to be for commands.

 -- Olly Betts <olly@survex.com>  Thu, 22 Nov 2018 16:52:39 +1300

therion (5.4.1ds1-6) unstable; urgency=medium

  * debian/rules: Convert to use dh.  This means we actually run
    dh_strip_nodeterminism.
  * debian/rules: Turn on bindnow hardening.
  * debian/therion.desktop,debian/therion-viewer.desktop: Add "Keywords".
  * debian/control: Note in therion-viewer package description that loch
    can also display Survex .3d and Compass .plt files.

 -- Olly Betts <olly@survex.com>  Tue, 13 Nov 2018 10:56:45 +1300

therion (5.4.1ds1-5) unstable; urgency=medium

  * debian/patches/99reproducible-builds.patch: No longer needed so drop.
    The PNG timestamps are removed by dh_strip_nondeterminism, and pdftex
    no longer embeds timestamps by default.
  * Update patch metadata.

 -- Olly Betts <olly@survex.com>  Thu, 08 Nov 2018 12:28:32 +1300

therion (5.4.1ds1-4) unstable; urgency=medium

  * debian/watch: Use https for upstream download page.
  * debian/patches/98reproducible-mpost.patch: New patch to set metapost
    randomseed to make build more reproducible.

 -- Olly Betts <olly@survex.com>  Fri, 26 Oct 2018 09:56:32 +1300

therion (5.4.1ds1-3) unstable; urgency=medium

  * New patch 05pkg-config-for-freetype.patch cherry-picked from upstream
    git master to switch from freetype-config to pkg-config.
    (Closes: #892453)
  * debian/source/options: Drop now-redundant 'compression = "xz"'.
  * debian/compat,debian/control: Update to use compat level 10
    instead of 9.
  * debian/control: Declare conformance with policy 4.2.1.
  * debian/changelog,debian/control,debian/rules: Remove trailing whitespace
    to silence pedantic lintian warning.

 -- Olly Betts <olly@survex.com>  Tue, 23 Oct 2018 16:43:14 +1300

=== debian/control ===
Source: therion
Section: science
Priority: optional
Maintainer: Wookey <wookey@debian.org>
Uploaders: Olly Betts <olly@survex.com>
Build-Depends: dpkg (>=1.16.2), debhelper (>= 10), perl (>= 5.5), tcl,
  libvtk6-dev, libwxgtk3.0-gtk3-dev, libfreetype6-dev, libjpeg-dev, libpng-dev,
  pkg-config, texlive-base, libproj-dev
Build-Depends-Indep: texlive-metapost, imagemagick, ghostscript
Standards-Version: 4.3.0
Homepage: https://therion.speleo.sk/

Package: therion
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, tcl, texlive-base, texlive-metapost, bwidget
Recommends: evince | pdf-viewer, libtk-img, therion-viewer, survex
Suggests: survex-aven, texlive-lang-czechslovak, texlive-lang-cyrillic
Description: Cave surveying - 2D and 3D drawing software
 Therion aids the process of drawing up cave surveys (maps). Drawings are
 done over scans and can be distorted to fit the centreline data. Output is
 in single sheet or atlas style PDF or SVG files. All data is stored in text
 files and a map editor (xtherion) is provided to aid in the creation of the
 files. A wide range of co-ordinate systems is supported.
 .
 Therion can also produce 3D models, generated from walls and
 passage-heights.  Output formats supported are Survex .3d files, VRML, DXF,
 SVG, shapefiles, and the native .lox. Scanned map overlays and relief data
 can be incorporated into models. Therion is compatible with Survex, and
 centreline data can be stored in Survex or Therion form. If survex is
 installed it is used for loop closures. Centreline data and sketches can be
 imported from PocketTopo, allowing full paperless surveying.
 .
 TeX and metapost are used to generate the images. libtk-img is needed to use
 scans in formats other than GIF and PNM (such as PNG and JPEG).
 Survex will be used for loop-closure if installed, but is not required.
 .
 You will need appropriate TeX language packages to process therion files which
 specify those character sets: texlive-lang-czechslovak is needed to process
 the examples, and texlive-lang-cyrillic is also suggested. See README.Debian
 for details.

Package: therion-viewer
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, therion
Description: Cave surveying - 3D viewer for therion models
 Therion is cave-survey drawing and modelling software. This package contains
 the 3D model viewer for therion models produced by version 0.4 or later.
 It can also display Survex .3d and Compass .plt files.

Package: therion-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Recommends: therion
Depends: ${misc:Depends}
Replaces: therion (<< 0.5.0)
Description: Documentation for Therion Cave surveying software
 Therion is cave-survey drawing and modelling software. This package
 includes the thbook which is the specification for the therion data
 description language. This is not the easiest way to get started;
 there is much more documentation in the Therion wiki:
 https://therion.speleo.sk/wiki/doku.php with introductory guides, FAQs
 and examples. Read those first to get an understanding of how it is
 used.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+bindnow

%:
	dh $@

override_dh_auto_build-indep:
	# just build the -doc package
ifeq ($(DEB_BUILD_ARCH),$(DEB_HOST_ARCH))
	# We need therion itself to build the samples
	$(MAKE) therion
	# create HTML documentation for samples
	$(MAKE) samples
endif
	$(MAKE) thbook

override_dh_auto_clean:
	$(MAKE) clean

override_dh_compress:
	dh_compress -X.pdf -X.th -X.th2 -Xthconfig

override_dh_auto_build-arch:
	# Compile the binaries
	$(MAKE) therion xtherion/xtherion loch/loch
	ln -sf loch.1 man/therion-viewer.7

override_dh_auto_install-arch:
	# we need to clear out large generated files from samples before putting just source files in main package
	$(MAKE) -C samples clean
	mkdir -p debian/tmp/usr/bin debian/tmp/etc
	dh_auto_install -- PREFIX=$(CURDIR)/debian/tmp/usr SYSCONFDIR=$(CURDIR)/debian/tmp/etc
	rm debian/tmp/etc/*.new
	cd loch/locale && for lang in * ; do \
	  install -D "$$lang/loch.mo" "debian/tmp/therion-viewer/usr/share/locale/$$lang/LC_MESSAGES/loch.mo" ; \
	done
	dh_installexamples -ptherion --exclude=.tcl --exclude=Makefile --exclude=thTMPDIR samples therion.ini
